Page MenuHomePhabricator

Display parent references of subreferences in the VE pop up and wizard
Closed, ResolvedPublic

Description

VE requirement (T245299):

  • As someone editing a sub-reference in VE, it should be clear you are editing a reference that has a relationship to other reference(s)
    • As someone editing a sub-reference in VE, it should be clear to you what reference said sub-reference relates to.

User story:
As an editor editing a sub-reference in an article in VE
I want understand that the article is a subreference
And I want to know which reference this subreference is related to
So that I know what information is already provided by the parent reference
And so that I know what information should/could be included in the subreference

Implementation:

  • pass the extends information with the reference model and display a warning when a reference is extending another one (to demo that the information is being passed through) patch
    Screenshot from 2023-05-12 10-36-58.png (250×739 px, 23 KB)
  • display text of parent reference before the extends content in the VE pop up (patch) - see also T239228 and its patch
    Screenshot from 2023-06-09 17-51-15.png (258×754 px, 33 KB)
  • display the text of the parent ref to the edit wizard of the sub-reference WITH the warning in the screenshot. The warning is important so that the user is alerted of what they are doing. The parent ref text is important so that the user can make a conscious decision based on what they see in the parent ref text (patch)
    Screenshot from 2023-06-09 17-00-13.png (336×805 px, 27 KB)

https://gerrit.wikimedia.org/r/1047510
edit dialog warning msg --> https://gerrit.wikimedia.org/r/c/mediawiki/extensions/Cite/+/1051181

  • make changes testable on beta
  • Todo: write task for UX with review items

Review Items for UX:

  • Review rendering with UX, and discuss next steps
  • Should a warning be included in the sub-reference edit dialog, or is displaying only the parent reference text sufficient?
  • Is the warning message with the parent reference text clearly visible?
  • Is the wording of the warning message "this is an extension of another reference" easy to understand?
  • Does the inclusion of the warning message enhance the editing experience?
  • Can users easily differentiate between parent refs and sub-refs?
  • Are there potential usability issues for users when editing a sub-reference?
  • Are users with disabilities able to create and edit sub-references (eg Screenreaders, keyboard navigation)
  • Are there any improvements needed to meet accessibility standards?
  • Is additional contextual help required to aid users in understanding the relationship between parent and sub-references?

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

Change 924502 had a related patch set uploaded (by Awight; author: Awight):

[mediawiki/extensions/Cite@master] Add a test for "extends" round-tripping

https://gerrit.wikimedia.org/r/924502

Change 924502 merged by jenkins-bot:

[mediawiki/extensions/Cite@master] Add a test for "extends" round-tripping

https://gerrit.wikimedia.org/r/924502

Change 927186 had a related patch set uploaded (by Svantje Lilienthal; author: Svantje Lilienthal):

[mediawiki/extensions/Cite@master] Use message widget for reuse warning in reference dialog

https://gerrit.wikimedia.org/r/927186

Change 927192 had a related patch set uploaded (by Svantje Lilienthal; author: Svantje Lilienthal):

[mediawiki/extensions/Cite@master] Add extends warning to reference dialog

https://gerrit.wikimedia.org/r/927192

Change 927222 had a related patch set uploaded (by Thiemo Kreuz (WMDE); author: Thiemo Kreuz (WMDE)):

[mediawiki/extensions/Cite@master] Reduce code duplication in ve.ui.MWReferenceDialog

https://gerrit.wikimedia.org/r/927222

Change 927222 abandoned by Thiemo Kreuz (WMDE):

[mediawiki/extensions/Cite@master] Reduce code duplication in ve.ui.MWReferenceDialog

Reason:

https://gerrit.wikimedia.org/r/927222

Change 927186 merged by jenkins-bot:

[mediawiki/extensions/Cite@master] Use message widget for reuse warning in reference dialog

https://gerrit.wikimedia.org/r/927186

Change 928865 had a related patch set uploaded (by Svantje Lilienthal; author: Svantje Lilienthal):

[mediawiki/extensions/Cite@master] Display text of parent reference in VE popup

https://gerrit.wikimedia.org/r/928865

Change 927192 merged by jenkins-bot:

[mediawiki/extensions/Cite@master] Add extends warning to reference dialog

https://gerrit.wikimedia.org/r/927192

Change 928865 merged by jenkins-bot:

[mediawiki/extensions/Cite@master] Display text of parent reference in VE popup

https://gerrit.wikimedia.org/r/928865

Change 934347 had a related patch set uploaded (by Awight; author: Awight):

[mediawiki/extensions/Cite@master] Revert "Add extends warning to reference dialog"

https://gerrit.wikimedia.org/r/934347

Change 934347 merged by jenkins-bot:

[mediawiki/extensions/Cite@master] Revert "Add extends warning to reference dialog"

https://gerrit.wikimedia.org/r/934347

Change 934350 had a related patch set uploaded (by Bartosz Dziewoński; author: Awight):

[mediawiki/extensions/Cite@wmf/1.41.0-wmf.15] Revert "Add extends warning to reference dialog"

https://gerrit.wikimedia.org/r/934350

Change 934350 merged by jenkins-bot:

[mediawiki/extensions/Cite@wmf/1.41.0-wmf.15] Revert "Add extends warning to reference dialog"

https://gerrit.wikimedia.org/r/934350

Mentioned in SAL (#wikimedia-operations) [2023-06-29T17:35:00Z] <taavi@deploy1002> Started scap: Backport for [[gerrit:934350|Revert "Add extends warning to reference dialog" (T247922 T340757)]]

Mentioned in SAL (#wikimedia-operations) [2023-06-29T17:38:16Z] <taavi@deploy1002> matmarex and taavi: Backport for [[gerrit:934350|Revert "Add extends warning to reference dialog" (T247922 T340757)]] synced to the testservers: mwdebug2002.codfw.wmnet, mwdebug2001.codfw.wmnet, mwdebug1002.eqiad.wmnet, mwdebug1001.eqiad.wmnet

Mentioned in SAL (#wikimedia-operations) [2023-06-29T17:46:07Z] <taavi@deploy1002> Finished scap: Backport for [[gerrit:934350|Revert "Add extends warning to reference dialog" (T247922 T340757)]] (duration: 11m 06s)

Change #1026594 had a related patch set uploaded (by Thiemo Kreuz (WMDE); author: Thiemo Kreuz (WMDE)):

[mediawiki/extensions/Cite@master] Streamline code dealing with (undeployed) extends attribute

https://gerrit.wikimedia.org/r/1026594

Change #1026594 merged by jenkins-bot:

[mediawiki/extensions/Cite@master] Streamline code dealing with (undeployed) extends attribute

https://gerrit.wikimedia.org/r/1026594

Change #1046708 had a related patch set uploaded (by Mareike Heuer; author: Mareike Heuer):

[mediawiki/extensions/Citoid@master] Display parent ref text with warning message

https://gerrit.wikimedia.org/r/1046708

MareikeHeuerWMDE updated the task description. (Show Details)
MareikeHeuerWMDE updated the task description. (Show Details)
MareikeHeuerWMDE updated the task description. (Show Details)
MareikeHeuerWMDE subscribed.

I unchecked one of the checkboxes above. The edge case we found is:

A<ref extends=book name=p20>p. 20</ref>
B<ref name=p20 />
C<ref extends=book name=p20 />
<references>
<ref name=book>book</ref>
</references>

This mostly works, with one exception. The ContextItem popup should be the same in all 3 cases, but doesn't show the parent on B. Apparently we created some code that relies on the extends= attribute being there. But this is not guaranteed when it's a reuse via name=. I wonder if this is worth a separate ticket?

Change #1047510 had a related patch set uploaded (by Thiemo Kreuz (WMDE); author: Thiemo Kreuz (WMDE)):

[mediawiki/extensions/Cite@master] [WIP] Fix parent missing on subrefs without extends attribute

https://gerrit.wikimedia.org/r/1047510

Change #1046708 merged by jenkins-bot:

[mediawiki/extensions/Citoid@master] Display parent ref text with warning message

https://gerrit.wikimedia.org/r/1046708

Change #1051181 had a related patch set uploaded (by Mareike Heuer; author: Mareike Heuer):

[mediawiki/extensions/Cite@master] Display extends warning message along with parent ref text in sub-ref edit dialog

https://gerrit.wikimedia.org/r/1051181

MareikeHeuerWMDE updated the task description. (Show Details)
MareikeHeuerWMDE updated the task description. (Show Details)

Change #1051181 merged by jenkins-bot:

[mediawiki/extensions/Cite@master] Display extends warning message when editing a reference

https://gerrit.wikimedia.org/r/1051181

WMDE-Fisch moved this task from Tech Review to Demo on the WMDE-TechWish-Sprint-2024-06-26 board.
WMDE-Fisch subscribed.
thiemowmde added a subscriber: ElineWMDE.

We decided to close this as being done and track the remaining issues in separate tickets:

  1. The edge-case I described above is now tracked in T369801: VE doesn't show parent reference on a subreference that is a reuse by name. This is not a blocker for our plan to do more user tests.
  2. We will iterate on the design. This can happen any time later.

Change #1053641 had a related patch set uploaded (by WMDE-Fisch; author: WMDE-Fisch):

[mediawiki/extensions/Cite@master] Use existing extends warning i18n

https://gerrit.wikimedia.org/r/1053641

Change #1053642 had a related patch set uploaded (by WMDE-Fisch; author: WMDE-Fisch):

[mediawiki/extensions/Citoid@master] Use existing extends warning i18n

https://gerrit.wikimedia.org/r/1053642

Change #1053641 merged by jenkins-bot:

[mediawiki/extensions/Cite@master] Use existing extends warning i18n

https://gerrit.wikimedia.org/r/1053641